public class Player : Equatable {
    public let name: String
    public let piece_type: PieceType
    
    public var type: PlayerType { fatalError("abstract property not implemented") }

    public init(name: String, piece_type: PieceType) {
        self.name = name
        self.piece_type = piece_type
    }

    public func chooseMove(allowed_moves moves: [Move.Action], board: Board) -> Move.Action {
        fatalError("abstract method not implemented")
    }
    
    /// Called when there is no possible move for this player's turn
    public func skipMove(board: Board) -> Void {
        // NO-OP
    }
    
    public static func == (lhs: Player, rhs: Player) -> Bool {
        // TODO: name equality or reference equality?
        lhs === rhs
    }
}

public enum PlayerType: CaseIterable {
    case Human
    case AIRandom
}
